Subject: Re: bug#62029: 29.0.60; Allow users to customize eldoc buffer separator

From: Yuan Fu <[email-masked]>
Date: Wed, 8 Mar 2023 13:28:39 -0800

> On Mar 8, 2023, at 9:14 AM, João Távora <[email-masked]> wrote:
> 
> Hi Yuan,
> 
> Mostly just replying so I'm kept in the loop.
> 
> I'm preparing a proposal for and Eldoc enhancements that could link with this.
> 
> For example, i don't think that the eldoc function that displays in the echo area should piggy-back on the contents of the eldoc doc buffer used by the other display function. This was a misdesign (by me). Each display function should be given as much information as possible and then decide how and where to render without affecting other members of 'eldoc-display-functions'.

I agree. It would be nice if eldoc can expose a variable containing the original value (a list of (doc :key :val…)). That’s essentially what the function in eldoc-box (eldoc-box-help-at-point) needed. Eldoc-box-help-at-point currently just copies the buffer text of eldoc--doc-buffer but it can be easily changed to copy from the aforementioned variable instead, and do it’s own formatting. (Alternatively eldoc-box-hel-at-point could TRT and invoke eldoc and get its output and show it, but simply using eldoc-doc-buffer is so easy and reliable ;-)

> 
> I think it's important to decide if things like line separation are properties of a given member of 'eldoc-display-function' or if eldoc in general. I strongly lean to the former.

I agree. But in the same time, eldoc’s rendering should be customizable too. If someone uses eldoc-doc-buffer and want to use fancier separators, they should be able to. That’ll be easier than writing another displayer that does everything the same as eldoc-doc-buffer except for using a different separator.

Yuan